//
//  main.cpp
//  EsmartTokenGost28147
//
//  Created by Sergey Panov on 28/02/2019.
//  Copyright © 2019 ISBC Group. All rights reserved.
//

#include "Utils.hpp"

CK_BYTE testGost28147KeyValue[] =
{ 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
    0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F };

CK_BYTE testGost28147KeyId[] = { 0x10, 0x11, 0x12, 0x13, 0x14, 0x15 };
CK_BYTE testGost28147KeyLabel[] = { 0x31, 0x32, 0x33, 0x34, 0x35, 0x36 };

CK_BYTE data[] = {
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8,
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8,
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8,
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8,
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8,
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8,
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8,
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8,
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8,
    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7, 0xF8
};

/**
 * Store key
 * \param hSession - session handled for opened session
 * \param phObject - object handler (CK_INVALID_HANDLE if not found)
 * \return - result code, if 0 - success otherwise error code returned
 */
CK_RV storeKey(CK_SESSION_HANDLE hSession, CK_OBJECT_HANDLE_PTR phObject)
{
    CK_OBJECT_CLASS keyClass = CKO_SECRET_KEY;
    CK_KEY_TYPE keyType = CKK_GOST28147;
    CK_BBOOL bTrue = CK_TRUE;
    CK_BBOOL bFalse = CK_FALSE;
    BYTE id_Gost28147_89_CryptoPro_A_ParamSet[] = { 0x06, 0x07, 0x2A, 0x85, 0x03, 0x02, 0x02, 0x1F, 0x01 };
    
    // template for the key
    CK_ATTRIBUTE attrTemplate[] = {
        { CKA_CLASS, &keyClass, sizeof(keyClass) },
        { CKA_KEY_TYPE, &keyType, sizeof(keyType) },
        { CKA_TOKEN, &bTrue, sizeof(bTrue) },
        { CKA_ID, (CK_VOID_PTR) testGost28147KeyId, sizeof(testGost28147KeyId) / sizeof(CK_BYTE) },
        { CKA_LABEL, (CK_VOID_PTR) testGost28147KeyLabel, sizeof(testGost28147KeyLabel) / sizeof(CK_BYTE) },
        { CKA_ENCRYPT, &bTrue, sizeof(bTrue) },
        { CKA_DECRYPT, &bTrue, sizeof(bTrue) },
        { CKA_WRAP, &bTrue, sizeof(bTrue) },
        { CKA_UNWRAP, &bTrue, sizeof(bTrue) },
        { CKA_EXTRACTABLE, &bFalse, sizeof(bFalse) },
        { CKA_GOST28147_PARAMS, id_Gost28147_89_CryptoPro_A_ParamSet, sizeof(id_Gost28147_89_CryptoPro_A_ParamSet) },
        { CKA_VALUE, (CK_VOID_PTR) testGost28147KeyValue, sizeof(testGost28147KeyValue) / sizeof(CK_BYTE) }
    };
    CK_ULONG attrTemplateSize = sizeof(attrTemplate) / sizeof (CK_ATTRIBUTE);

    CK_RV rv = p11->C_CreateObject(hSession, attrTemplate, attrTemplateSize, phObject);
    if (rv != CKR_OK) {
        cout << "C_CreateObject for key failed. Code: " << rv << endl;
        return rv;
    }
    
    return rv;
}

/**
 * detele object
 * \param hSession - session handled for opened session
 * \return - result code, if 0 - success otherwise error code returned
 */
CK_RV deleteKey(CK_SESSION_HANDLE hSession) {
    CK_RV            rv = CKR_OK;
    CK_OBJECT_HANDLE     hObject;
    CK_ULONG         ulObjectCount;
    CK_ATTRIBUTE attrTemplate[] = {
        { CKA_ID, (CK_VOID_PTR) testGost28147KeyId, sizeof(testGost28147KeyId) / sizeof(CK_BYTE) }
    };
    CK_ULONG attrTemplateSize = sizeof(attrTemplate) / sizeof (CK_ATTRIBUTE);;
    
    rv = p11->C_FindObjectsInit(hSession, attrTemplate, attrTemplateSize);
    if (rv != CKR_OK) {
        cout << "C_FindObjectsInit failed. Code: " << rv << endl;
        return rv;
    }
    
    rv = p11->C_FindObjects(hSession, &hObject, 1, &ulObjectCount);
    if (rv != CKR_OK) {
        cout << "C_FindObjects failed. Code: " << rv << endl;
    }
    else if (ulObjectCount == 0) {
        cout << "C_FindObjects object not found. Code: " << rv << endl;
        p11->C_FindObjectsFinal(hSession);
        return CKR_FUNCTION_FAILED;
    }
    else {
        p11->C_FindObjectsFinal(hSession);
        rv = p11->C_DestroyObject(hSession, hObject);
        if (rv != CKR_OK) {
            cout << "C_DestroyObject failed for " << hObject << ". Code: " << rv << endl;
        }
    }

    return rv;
}

int main(int argc, const char * argv[]) {
    int res = init();
    if (res != 0) {
        return res;
    }
    
    // open session
    CK_SLOT_ID SlotId = 0;
    CK_RV rv = p11->C_OpenSession(SlotId, CKF_SERIAL_SESSION | CKF_RW_SESSION, NULL, NULL, &hSession);
    
    if(rv != CKR_OK) {
        cout << "C_OpenSession failed. Code: " << rv << endl;
        cleanup();
        return 6;
    }

    cout << "Please enter PIN (User PIN): ";
    SetStdinEcho(false);
    string pin;
    cin >> pin;
    SetStdinEcho(true);
    cout << endl;
    
    vector<BYTE> pinBuff(pin.begin(), pin.end());
    rv = p11->C_Login(hSession, CKU_USER, &pinBuff[0], static_cast<ULONG>(pinBuff.size()));
    if (rv != CKR_OK && rv != CKR_USER_ALREADY_LOGGED_IN) {
        cout << "Login failed. Code: " << rv << endl;
        cleanup();
        return 7;
    }
    
    // store key
    CK_OBJECT_HANDLE hObject;
    rv = storeKey(hSession, &hObject);
    if (rv != CKR_OK) {
        cout << "storeKey failed. Code: " << rv << endl;
        cleanup();
        return 8;
    }
    
    // init sing by GOST 28147-89 MAC
    CK_MECHANISM gost28147MacMechanism = { CKM_GOST28147_MAC, NULL_PTR, 0 };
    // GOST 28147-89 MAC is 4 bytes
    vector<CK_BYTE> signBuff(4, 0);
    CK_ULONG signBuffSize = static_cast<CK_ULONG>(signBuff.size());
    
    rv = p11->C_SignInit(hSession, &gost28147MacMechanism, hObject);
    if (rv != CKR_OK) {
        cout << "C_SignInit failed. Code: " << rv << endl;
        cleanup();
        return 9;
    }
    rv = p11->C_Sign(hSession, data, sizeof(data), &signBuff[0], &signBuffSize);
    if (rv != CKR_OK) {
        cout << "C_Sign failed. Code: " << rv << endl;
        cleanup();
        return 10;
    }
    cout << "Data: " << getString(data, sizeof(data)) << endl;;
    cout << "MAC value: " << getString(signBuff) << endl;
    
    rv = deleteKey(hSession);
    if (rv != CKR_OK) {
        cout << "deleteKey failed. Code: " << rv << endl;
        cleanup();
        return 11;
    }
    
    cleanup();
    return 0;
}
