/**
 *  ESMART Token v3.1 - PKCS#11 Sample
 *
 *  Description: Provides interface to format token, change PIN
 *               and list token objects.
 *
 *  $Author: Alexander Revo
 *  $Date: 14.04.2014
 *  $Id: 3513-02-010
 *
 *  Copyright 2014 by ISBC Group
 *  All rights reserved.
 */

// Throws CPKCSException, std::exception

#include "..\common\TokenOperator.h"

#pragma once

class CBasicOperator : public CTokenOperator
{
public: // Definitions
	enum { MAX_LABEL_SIZE = 32 };
public: // CTORs
	CBasicOperator() {};
	virtual ~CBasicOperator() {};
private: // CTORs
	CBasicOperator(const CBasicOperator&) {};
public: // Interface
	void FormatToken();
	void ChangePin();
	void GetObjects();
private: // Member functions
	void AskForLabel(CK_UTF8CHAR_PTR pBuffer, const CK_ULONG ulBufSize);
};
