/**
 *  ESMART Token v3.1 - PKCS#11 Sample
 *
 *  Description: Provides interface to work with signatures and certificates
 *
 *  $Author: Alexander Revo
 *  $Date: 14.04.2014
 *  $Id: 3513-03-010
 *
 *  Copyright 2014 by ISBC Group
 *  All rights reserved.
 */

// Throws CPKCSException, std::exception

#include "..\common\TokenOperator.h"
#include "..\SignatureTest\gost.h"



#pragma once

class CSignatureOperator : public CTokenOperator
{
public: // CTORs
	CSignatureOperator() {};
	virtual ~CSignatureOperator() {};
private: // CTORs
	CSignatureOperator(const CSignatureOperator&) {};
public: // Interface
	void GenerateRsaPair();
	void GenerateCSR();
	void LoadCertificate();
	void SignAndVerifyWithCertificate();
	void SignAndVerifyWithKey();
	void SignAndVerifyWithGostKey();
	void GenerateGost3410Pair ();

	void DeleteRsaPair();
	void test();
	void TestGost ();
	void logout ();
	//void Auth();

	int bit;



private: // Member functions
	std::string AskForFilePath(const std::string& rPathToWhat);
	void WriteToFile(CK_BYTE_PTR pData, const CK_ULONG ulDataLength);
	bool ReadCertificateFile(const char* pFilepath,
		std::vector<CK_BYTE>& rCertificate);
	CK_OBJECT_HANDLE FindObject(CK_ATTRIBUTE_PTR pAttributes,
		const CK_ULONG ulAttrNumber);
	CK_OBJECT_HANDLE FindPublicKey();
	CK_OBJECT_HANDLE FindPrivateKey();
	CK_OBJECT_HANDLE FindCertificate();
	std::vector<CK_CHAR> MakeContiguous(char** pData, const size_t size);
};
