/**
 *  ESMART Token v3.1 - PKCS#11 Sample
 *
 *  Description: Exception class for PKCS-related errors
 *
 *  $Author: Alexander Revo
 *  $Date: 14.04.2014
 *  $Id: 3513-01-020
 *
 *  Copyright 2014 by ISBC Group
 *  All rights reserved.
 */


#include "pkcs_definitions.h"
#include <string>

#pragma once

class CPKCSException
{
public: // CTORs
	CPKCSException(const CK_RV& rv, char* moduleName)
		: mCode(rv), mModuleName(moduleName) {};
	CPKCSException(const CPKCSException& rhs) {};
	virtual ~CPKCSException() {};
public: // Interface
	CK_RV What() const { return mCode; };
	std::string Where() const { return mModuleName; };
private: // Data members
	CK_RV mCode;
	std::string mModuleName;
};
